------------------------------------------------------------------------------
--                                                                          --
--                               AstroFrames                                --
--                                                                          --
--                              ASPECT_MODELS                               --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--                            $Revision: 1.3 $
--                                                                          --
--                       Copyright (C) 2001 Ed Falis                        --
--                                                                          --
-- This is free software;  you can  redistribute it  and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion.  This is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License  distributed with this;  see file COPYING.  If not, write --
-- to  the Free Software Foundation,  59 Temple Place - Suite 330,  Boston, --
-- MA 02111-1307, USA.                                                      --
--                                                                          --
-- This software  is maintained by Ed Falis (falis@adelphia.net)            --
--                                                                          --
------------------------------------------------------------------------------
with Publish_Subscribe; use Publish_Subscribe;

--  Models of aspect selections
package body Aspect_Models is

   ---------------
   --  Queries  --
   ---------------

   function Selection
     (M : access Aspect_Model)
      return Aspect_Selection
   is
   begin
      return M.Selection;
   end Selection;

   ------------------------
   --  Basic Operations  --
   ------------------------

   procedure Update (M : access Aspect_Model;
                     Selection : Aspect_Selection) is
   begin
      M.Selection := Selection;
      Notify_Observers (M, new Event);
   end Update;

end Aspect_Models;

