------------------------------------------------------------------------------
--                                                                          --
--                               AstroFrames                                --
--                                                                          --
--                         COORDINATE_CONVERSIONS                           --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--                            $Revision: 1.3 $
--                                                                          --
--                       Copyright (C) 2001 Ed Falis                        --
--                                                                          --
-- This is free software;  you can  redistribute it  and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion.  This is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License  distributed with this;  see file COPYING.  If not, write --
-- to  the Free Software Foundation,  59 Temple Place - Suite 330,  Boston, --
-- MA 02111-1307, USA.                                                      --
--                                                                          --
-- This software  is maintained by Ed Falis (falis@adelphia.net)            --
--                                                                          --
------------------------------------------------------------------------------

--  Coordinate conversions utility package
package Coordinate_Conversions is

   --  2D record for coordinate conversions.  Negative initial
   --  value indicates the field is uninitialized
   type Coord_2d is record
     Long, Lat : Long_Float := -1.0;
   end record;

   --  Equatorial to ecliptic conversion
   function To_Ecliptic (Coordinates : Coord_2d;
                         Obliquity : Long_Float) return Coord_2d;

   --  Ecliptic to equatorial conversion
   function To_Equatorial (Coordinates : Coord_2d;
                           Obliquity : Long_Float) return Coord_2d;

end Coordinate_Conversions;
